package org.coderu.core.api;

import java.io.File;

import javax.annotation.Nullable;

import org.coderu.common.utils.types.SingleValue;

import com.google.common.base.Function;
import com.google.common.collect.Ordering;

@SuppressWarnings("serial")
public class CompileUnit extends SingleValue<File> implements
        Comparable<SingleValue<File>> {

    public static final Ordering<CompileUnit> ORDERING = new Ordering<CompileUnit>() {

        @Override
        public int compare(@Nullable CompileUnit left,
                @Nullable CompileUnit right) {
            return left.compareTo(right);
        }
    };

    public static final Function<String, CompileUnit> FROM_STRING = new Function<String, CompileUnit>() {

        @Override
        public CompileUnit apply(String arg0) {
            return new CompileUnit(new File(arg0));
        }
    };

    public static final Function<CompileUnit, File> TO_FILE = new Function<CompileUnit, File>() {

        public File apply(CompileUnit o) {
            return o.getValue();
        }
    };

    public CompileUnit(File value) {
        super(value);
    }

    @Override
    public int compareTo(SingleValue<File> arg0) {
        return this.getValue().compareTo(arg0.getValue());
    }
}
