package org.coderu.core.api;

import org.apache.commons.lang3.Validate;
import org.coderu.common.utils.types.SingleValue;

@SuppressWarnings("serial")
public class Depth extends SingleValue<Integer>{

    public static final Depth UNLIMITED = new Depth(-1,true);
    
    public static Depth add(final Depth first, final Depth second){
        if(first == UNLIMITED || second == UNLIMITED){
            return UNLIMITED;
        }else{
            return new Depth(first.getValue()+second.getValue()); 
        }
    }
    
    public Depth(int depth) {
        this(depth, false);
    }
    
    private Depth(int depth, boolean canBeZero) {
        super(depth);
        Validate.isTrue(canBeZero || depth>=0, "depth must be positive");
    }

    @Override
    public Integer getValue() {
    
        Validate.isTrue(this!=UNLIMITED, "unlimited does not have value");
        return super.getValue();
    }
}
