package org.coderu.core.impl.common.types;

import org.coderu.common.utils.types.AbstractPair;

import com.google.common.base.Function;


@SuppressWarnings("serial")
public final class PackageDependency extends AbstractPair<PackageName,PackageName>{

    public static Function<PackageName,PackageDependency> bindFrom(final PackageName from){
        return new Function<PackageName,PackageDependency>(){

            public PackageDependency apply(PackageName to) {
                return new PackageDependency(from,to) ;
            }

        };
    }

    public PackageDependency(PackageName from, PackageName to) {
        super(from, to);
    }

    public PackageName getFrom(){
        return getFirst();
    }

    public PackageName getTo(){
        return getSecond();
    }

}
