package org.coderu.core.impl.explorer.parser.impl;

import java.io.IOException;
import java.io.InputStream;
import java.util.Collection;

import org.apache.commons.io.IOUtils;
import org.coderu.common.utils.CollectionUtils;
import org.coderu.core.api.Clazz;
import org.coderu.core.impl.explorer.parser.impl.loader.bytecode.ByteCodeParser;
import org.objectweb.asm.ClassReader;

import com.google.common.base.Function;
import com.google.common.base.Supplier;


public final class ClassParser implements Function<Supplier<InputStream>,Collection<Clazz>> {

    public Collection<Clazz> apply(Supplier<InputStream> o) {

        final InputStream is = o.get();

        try {
            final ClassReader classReader = new ClassReader(is);
            final ByteCodeParser byteCodeParser = new ByteCodeParser();
            classReader.accept(byteCodeParser, 0);
            return CollectionUtils.removeDuplicates(byteCodeParser.getTypes());
        }
        catch (IOException e) {
            throw new RuntimeException(e);
        }
        finally{
            IOUtils.closeQuietly(is);
        }
    }

}
